import SpriteKit

public class InfoScene: SKScene {
    
    var infoText:SKLabelNode = SKLabelNode()
    
    var typingIndex = Int()
    var typingText = Array<Character>()
    
    var section = 0
    
    public override func didMove(to view: SKView) {
        super.didMove(to: view)
        infoText = childNode(withName: "infoText") as! SKLabelNode
        startInfoSequence()
    }
    
    func startInfoSequence() {
        switch section {
        case 0:
            prepareTyping(textToAnimate: "Your mouse is now a physics-based bit")
        case 1:
            prepareTyping(textToAnimate: "Sent from 1 Apple Park Way")
        case 2:
            prepareTyping(textToAnimate: "To Colts Neck, New Jersey")
        case 3:
            prepareTyping(textToAnimate: "Help me get the WWDC stream to my house!")
        case 4:
            loadSelectionScene()
        default:
            prepareTyping(textToAnimate: "Help me get the WWDC stream to my house!")
        }
        
    }
    
    func prepareTyping(textToAnimate:String) {
        typingText = Array(textToAnimate)
        typingIndex = 0
        if (infoText.text != "") {
            infoText.text = ""
            animateTyping()
        } else {
            animateTyping()
        }
    }
    
    func animateTyping() {
        if (typingIndex < typingText.count) {
            infoText.text = infoText.text! + String(typingText[typingIndex])
            typingIndex += 1
            let randomWait = TimeInterval.random(in: 0.05...0.3)
            DispatchQueue.main.asyncAfter(deadline: .now() + randomWait, execute: {
                self.animateTyping()
            })
        } else {
            section += 1
            DispatchQueue.main.asyncAfter(deadline: .now() + 2, execute: {
                self.startInfoSequence()
            })
        }
    }
    
    func loadSelectionScene() {
        let transition = SKTransition.push(with: .left, duration: 1)
        guard let selectionScene = SelectionScene(fileNamed: "SelectionScene") else {
            fatalError("Unable to load selectionScene")
        }
        selectionScene.level = 1
        self.scene?.view?.presentScene(selectionScene, transition: transition)
    }
}
