import SpriteKit

public class SelectionScene: SKScene {
    
    var level = Int()
    
    let infiniteLoop = SKSpriteNode(imageNamed: "applelocation.png")
    let levelOne = SKSpriteNode(imageNamed: "1.png")
    let levelTwo = SKSpriteNode(imageNamed: "2.png")
    let levelThree = SKSpriteNode(imageNamed: "3.png")
    let levelFour = SKSpriteNode(imageNamed: "4.png")
    let levelFive = SKSpriteNode(imageNamed: "5.png")
    let endHouse = SKSpriteNode(imageNamed: "house.png")
    
    public override func didMove(to view: SKView) {
        super.didMove(to: view)
        infiniteLoop.position = CGPoint(x: -220, y: 0)
        infiniteLoop.size = CGSize(width: 100, height: 100)
        levelOne.position = CGPoint(x: -120, y: 60)
        levelOne.size = CGSize(width: 100, height: 100)
        levelTwo.position = CGPoint(x: -60, y: -60)
        levelTwo.size = CGSize(width: 100, height: 100)
        levelThree.position = CGPoint(x: 0, y: 60)
        levelThree.size = CGSize(width: 100, height: 100)
        levelFour.position = CGPoint(x: 60, y: -60)
        levelFour.size = CGSize(width: 100, height: 100)
        levelFive.position = CGPoint(x: 120, y: 60)
        levelFive.size = CGSize(width: 100, height: 100)
        endHouse.position = CGPoint(x: 220, y: 0)
        endHouse.size = CGSize(width: 100, height: 100)
        addChild(infiniteLoop)
        addChild(levelOne)
        addChild(levelTwo)
        addChild(levelThree)
        addChild(levelFour)
        addChild(levelFive)
        addChild(endHouse)
    }
    
    public override func mouseDown(with event: NSEvent) {
        super.mouseDown(with: event)
        let location = event.location(in: self)
        let nodes = self.nodes(at: location)
        if (nodes.contains(levelOne)) {
            toGame(num: 1)
        } else if (nodes.contains(levelTwo)) {
            toGame(num: 2)
        }
    }
    
    func toGame(num:Int) {
        let transition = SKTransition.fade(withDuration: 0.5)
        switch num {
        case 1:
            guard let game1Scene = Game1(fileNamed: "Game1") else {
                fatalError("Unable to load Game1")
            }
            self.scene?.view?.presentScene(game1Scene, transition: transition)
        case 2:
            guard let game2Scene = Game2(fileNamed: "Game2") else {
                fatalError("Unable to load Game1")
            }
            self.scene?.view?.presentScene(game2Scene, transition: transition)
        default:
            guard let game1Scene = Game1(fileNamed: "Game1") else {
                fatalError("Unable to load Game1")
            }
            self.scene?.view?.presentScene(game1Scene, transition: transition)
        }
    }
}
 
