import SpriteKit

public class TitleScene: SKScene {
    
    var playerBit = SKLabelNode(text: "010")
    var playerParticle = SKEmitterNode(fileNamed: "TrailParticle")
    
    public override func didMove(to view: SKView) {
        if (playerParticle == nil) {
            fatalError("Unable to load playerParticle")
        }
        playerBit.insertChild(playerParticle!, at: 0)
        playerBit.children[0].position = CGPoint(x: -40, y: 9)
        playerBit.children[0].isHidden = true
        playerBit.children[0].alpha = 0
        playerBit.fontSize = 25
        addChild(playerBit)
    }
    
    public override func mouseDown(with event: NSEvent) {
        super.mouseDown(with: event)
        startGame()
    }
    
    public override func update(_ currentTime: TimeInterval) {
        super.update(currentTime)
        playerTextChange()
    }
    
    func playerTextChange() {
        let random = Int.random(in: 0..<600)
        if (random > 200 && random < 300) {
            let selectType = Int.random(in: 0..<6)
            switch selectType {
            case 1:
                playerBit.text = "000"
            case 2:
                playerBit.text = "001"
            case 3:
                playerBit.text = "010"
            case 4:
                playerBit.text = "100"
            case 5:
                playerBit.text = "101"
            case 6:
                playerBit.text = "111"
            default:
                playerBit.text = "010"
            }
        }
    }
    
    func startGame() {
        let opacityAction = SKAction.fadeAlpha(to: 1, duration: 1.0)
        playerBit.children[0].isHidden = false
        playerBit.children[0].run(SKAction.sequence([opacityAction, SKAction.run({
            self.slideOutPlayer()
        })]))
    }
    
    func slideOutPlayer() {
        let moveAction = SKAction.move(to: CGPoint(x: 680, y: 0), duration: 2.0)
        playerBit.run(SKAction.sequence([moveAction, SKAction.removeFromParent(), SKAction.run {
            self.loadInfoScene()
        }]))
    }
    
    func loadInfoScene() {
        let transition = SKTransition.push(with: .left, duration: 1)
        guard let infoScene = InfoScene(fileNamed: "InfoScene") else {
            fatalError("Unable to load infoScene")
        }
        self.scene?.view?.presentScene(infoScene, transition: transition)
    }
}
